      SUBROUTINE SPELL_LOAD(LANG)
      CHARACTER*(*) LANG
C
C     Global variables
      INCLUDE 'SPELL_COMMON'
C
C     Local variables
      INTEGER*4 I
C
C     Load dictionary
      OPEN(UNIT=1,FILE='XEVEDIR:SPELL_'//LANG//'.DAT',STATUS='OLD',
     +     READONLY,ERR=300)
      I=1
100   READ(UNIT=1,FMT='(Q,A24)',END=200) LWRD(I),WRD(I)
      I=I+1
      GOTO 100
200   NWRD=I-1
      CLOSE(UNIT=1)
C
300   RETURN
      END
C********************
      SUBROUTINE SPELL_LOAD_LOCAL(LANG)
      CHARACTER*(*) LANG
C
C     Global variables
      INCLUDE 'SPELL_COMMON'
C
C     Local variables
      INTEGER*4 I
C
C     Load dictionary
      OPEN(UNIT=1,FILE='SYS$LOGIN:SPELL_'//LANG//'.DAT',STATUS='OLD',
     +     READONLY,ERR=300)
      I=NWRD
100   I=I+1
      READ(UNIT=1,FMT='(Q,A24)',END=200) LWRD(I),WRD(I)
      GOTO 100
200   NWRD=I-1
      CLOSE(UNIT=1)
C
300   RETURN
      END
C********************
      LOGICAL*4 FUNCTION SPELL_TEST_WORD(TSTWRD)
      CHARACTER*(*) TSTWRD
C
C     Global variables
      INCLUDE 'SPELL_COMMON'
C
C     Local variables
      INTEGER*4 I,TOP,BOT,L
C
C     Statement functions
      CHARACTER*1 K
      LOGICAL*4 OK
      OK(K)=(K.GE.'A'.AND.K.LE.'Z').OR.(K.GE.'a'.AND.K.LE.'z').OR.
     +      K.EQ.''.OR.K.EQ.''.OR.K.EQ.''.OR.
     +      K.EQ.''.OR.K.EQ.''.OR.K.EQ.''
C
C     Test if word is in dictionary
      L=LEN(TSTWRD)
      DO 50 I=1,L-1
        IF(.NOT.OK(TSTWRD(I:I))) THEN
          SPELL_TEST_WORD=.TRUE.
          RETURN
        ENDIF
50    CONTINUE
      IF(.NOT.OK(TSTWRD(L:L))) L=L-1
      BOT=1
      TOP=NWRD
100   I=(TOP+BOT)/2
      IF(TSTWRD(1:L).EQ.WRD(I)(1:LWRD(I))) THEN
        SPELL_TEST_WORD=.TRUE.
        RETURN
      ELSE IF(TSTWRD(1:L).GT.WRD(I)(1:LWRD(I))) THEN
        BOT=I+1
      ELSE IF(TSTWRD(1:L).LT.WRD(I)(1:LWRD(I))) THEN
        TOP=I-1
      ENDIF
      IF(TOP.GE.BOT) GOTO 100
      SPELL_TEST_WORD=.FALSE.
      RETURN
C
      END
C********************
      INTEGER*4 FUNCTION SPELL_TEST_LINE(LINE)
      CHARACTER*(*) LINE
C
C     Global variables
      INCLUDE 'SPELL_COMMON'
C
C     Local variables
      INTEGER*4 IX,IX2,L
C
C     Functions
      LOGICAL*4 SPELL_TEST_WORD
C
C     Test if all words is in dictionary
      IX=1
      L=LEN(LINE)
100   IF(LINE(IX:IX).EQ.' ') THEN
        IX=IX+1
      ELSE
        IX2=INDEX(LINE(IX:L)//' ',' ')-1
        IF(SPELL_TEST_WORD(LINE(IX:IX+IX2-1))) THEN
          IX=IX+IX2
        ELSE
          GOTO 200
        ENDIF
      ENDIF
      IF(IX.LE.L) GOTO 100
200   SPELL_TEST_LINE=IX
C
      RETURN
      END
